/*
 *     WriteCFG.java  Aug 10, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph.cfg;
import org.jtool.platform.xml.dom.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.util.*;
import org.jtool.platform.j2xml.SystemProperties;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;

public class WriteCFG {
    public static void main(String[] args) {
        if (args.length == 1) {
            try {
                String fileName = SystemProperties.getCanonicalPath(args[0]);
                String text = ReadFile.read(fileName);
                Document doc = DOMTreeCreator.create(text);
                JavaFile jfile = new JavaFile(doc.getDocumentElement());

                Iterator it = jfile.getClassNodes().iterator();
                while (it.hasNext()) {
                    JavaClass jc = new JavaClass((Node)it.next());

                    StringBuffer buf = new StringBuffer();
                    makeCFG(jc.getConstructorNodes(), buf);
                    makeCFG(jc.getMethodNodes(), buf);

                    System.out.println(buf);
                }
            } catch (IOException e) { }
                
        } else {
            System.err.println("Usage: java WriteCFG xml_filename");
        }
    }

    private static void makeCFG(ArrayList methods, StringBuffer buf) {
        Iterator it = methods.iterator();
        while (it.hasNext()) {
            try {
                CFG cfg = new CFG((Node)it.next());
                buf.append(cfg.write());
            } catch (CFGException e) {
                System.err.println(e.getMessage());
            }
        }
    }
}
